(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('pouchdb'), require('pouchdb-find')) :
    typeof define === 'function' && define.amd ? define('asorm', ['exports', 'pouchdb', 'pouchdb-find'], factory) :
    (global = global || self, factory(global.asorm = {}, global.PouchDB, global.PouchdbFind));
}(this, (function (exports, PouchDB, PouchdbFind) { 'use strict';

    PouchDB = PouchDB && PouchDB.hasOwnProperty('default') ? PouchDB['default'] : PouchDB;
    PouchdbFind = PouchdbFind && PouchdbFind.hasOwnProperty('default') ? PouchdbFind['default'] : PouchdbFind;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/helpers/constants.helper.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ConstantsHelper = /** @class */ (function () {
        function ConstantsHelper() {
        }
        ConstantsHelper.CONFIG_KEY = 'AsromConfig';
        return ConstantsHelper;
    }());
    if (false) {
        /** @type {?} */
        ConstantsHelper.CONFIG_KEY;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/db.manager.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    PouchDB.plugin(PouchdbFind);
    // @dynamic
    var 
    // @dynamic
    DbManager = /** @class */ (function () {
        function DbManager() {
            PouchDB.plugin(PouchdbFind);
            this.dbs = [];
        }
        /**
         * @return {?}
         */
        DbManager.getInstance = /**
         * @return {?}
         */
        function () {
            if (this.instance === undefined) {
                this.instance = new DbManager();
            }
            return this.instance;
        };
        /**
         * @param {?} db
         * @return {?}
         */
        DbManager.prototype.addDB = /**
         * @param {?} db
         * @return {?}
         */
        function (db) {
            this.dbs.push(db);
        };
        /**
         * @param {?} db
         * @return {?}
         */
        DbManager.prototype.remove = /**
         * @param {?} db
         * @return {?}
         */
        function (db) {
            // tslint:disable-next-line:no-shadowed-variable
            this.dbs = this.dbs.filter((/**
             * @param {?} db
             * @return {?}
             */
            function (db) {
                return db !== db;
            }));
        };
        /**
         * @param {?} name
         * @return {?}
         */
        DbManager.prototype.getDBByName = /**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            return this.dbs.find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.name === name; }));
        };
        /**
         * @return {?}
         */
        DbManager.prototype.getAll = /**
         * @return {?}
         */
        function () {
            return this.dbs;
        };
        /**
         * @return {?}
         */
        DbManager.prototype.getMasterDatabaseName = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var masterConf = {
                dbName: '',
                password: ''
            };
            masterConf = JSON.parse(localStorage.getItem(ConstantsHelper.CONFIG_KEY));
            return masterConf.dbName;
        };
        /**
         * @return {?}
         */
        DbManager.prototype.getBaseDb = /**
         * @return {?}
         */
        function () {
            if (this.baseDb == null || this.baseDb === undefined) {
                this.baseDb = this.createBaseDB();
            }
            return this.baseDb;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        DbManager.prototype.setBaseDB = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.baseDb = value;
        };
        /**
         * @private
         * @return {?}
         */
        DbManager.prototype.createBaseDB = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var db;
            if (this.getMasterDatabaseName() !== undefined && this.getMasterDatabaseName() !== '') {
                PouchDB.plugin(PouchdbFind);
                db = new PouchDB(this.getMasterDatabaseName(), { auto_compaction: true });
                return {
                    name: this.getMasterDatabaseName(),
                    db: db
                };
            }
            return null;
        };
        return DbManager;
    }());
    if (false) {
        /** @type {?} */
        DbManager.instance;
        /**
         * @type {?}
         * @private
         */
        DbManager.prototype.dbs;
        /**
         * @type {?}
         * @private
         */
        DbManager.prototype.baseDb;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/attachment/attachement.manager.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AttachementManager = /** @class */ (function () {
        function AttachementManager(db) {
            this.db = db;
        }
        /**
         * @param {...?} args
         * @return {?}
         */
        AttachementManager.prototype.delete = /**
         * @param {...?} args
         * @return {?}
         */
        function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
        };
        /**
         * @param {?} _id
         * @param {?} name
         * @return {?}
         */
        AttachementManager.prototype.get = /**
         * @param {?} _id
         * @param {?} name
         * @return {?}
         */
        function (_id, name) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.db.getAttachment(_id, name)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @param {?} attachement
         * @return {?}
         */
        AttachementManager.prototype.save = /**
         * @param {?} attachement
         * @return {?}
         */
        function (attachement) {
            return __awaiter(this, void 0, void 0, function () {
                var blob, result, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            blob = new Blob([attachement.content], { type: attachement.type });
                            return [4 /*yield*/, this.db.putAttachment(attachement.docId, attachement.attachmentId, blob, attachement.type)];
                        case 1:
                            result = _a.sent();
                            return [2 /*return*/, result];
                        case 2:
                            err_1 = _a.sent();
                            console.log(err_1);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        return AttachementManager;
    }());
    if (false) {
        /** @type {?} */
        AttachementManager.prototype.db;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/helpers/operator.helper.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var OperatorHelper = /** @class */ (function () {
        function OperatorHelper() {
        }
        /**
         * @param {?} operator
         * @param {?} value
         * @return {?}
         */
        OperatorHelper.getValueWithOperator = /**
         * @param {?} operator
         * @param {?} value
         * @return {?}
         */
        function (operator, value) {
            switch (operator) {
                case '<':
                    return { $lt: value };
                case '>':
                    return { $gt: value };
                case '<=':
                    return { $lte: value };
                case '>=':
                    return { $gte: value };
                case '=':
                    return { $eq: value };
                case '!=':
                    return { $ne: value };
                case 'in':
                    return { $in: value };
                case 'like':
                    return { $regex: value };
                case 'match':
                    return { $elemMatch: value };
                default: {
                    throw new Error('Operator not found');
                }
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        OperatorHelper.getEqualOperator = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return { $eq: value };
        };
        /**
         * @param {?} value
         * @return {?}
         */
        OperatorHelper.buildOrOperation = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return {
                $or: value
            };
        };
        return OperatorHelper;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/dao.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    PouchDB.plugin(PouchdbFind);
    /**
     * @param {?} Class
     * @param {?=} name
     * @return {?}
     * @this {*}
     */
    function Dao(Class, name) {
        return (/**
         * @template T
         * @param {?} constructor
         * @return {?}
         */
        function (constructor) {
            return /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    var _this = _super.call(this, arguments) || this;
                    _this.query = { selector: {} };
                    PouchDB.plugin(PouchdbFind);
                    _this.tableName = name ? name : (new Class()).constructor.name;
                    _this.isFromBase = _this.isFromBase = (Object.getPrototypeOf((new Class()).constructor) + '').includes('BaseEntity');
                    _this.database = _this.isFromBase ? DbManager.getInstance().getBaseDb().db : DbManager.getInstance().getDBByName(_this.tableName).db;
                    return _this;
                }
                /**
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.get = /**
                 * @param {?=} callback
                 * @return {?}
                 */
                function (callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var where;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!!this.isFromBase) return [3 /*break*/, 2];
                                    if (!callback) {
                                        return [2 /*return*/, this.getDocsInPromise()];
                                    }
                                    if (callback.onPreExecute) {
                                        callback.onPreExecute();
                                    }
                                    return [4 /*yield*/, this.getDocsWithCallBack(callback)];
                                case 1:
                                    _a.sent();
                                    if (callback.onPostExecute) {
                                        callback.onPostExecute();
                                    }
                                    return [2 /*return*/];
                                case 2:
                                    where = this.where('table', this.tableName, '=');
                                    if (callback) {
                                        where.apply(callback);
                                    }
                                    else {
                                        return [2 /*return*/, where.apply()];
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?} callback
                 * @return {?}
                 */
                class_1.prototype.getDocsWithCallBack = /**
                 * @param {?} callback
                 * @return {?}
                 */
                function (callback) {
                    var _this = this;
                    return new Promise((/**
                     * @param {?} resolve
                     * @return {?}
                     */
                    function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                        var docs, e_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, this.database.allDocs({
                                            include_docs: true,
                                            attachments: true
                                        })];
                                case 1:
                                    docs = _a.sent();
                                    docs.rows = docs.rows.map((/**
                                     * @param {?} item
                                     * @return {?}
                                     */
                                    function (item) {
                                        return item.doc;
                                    }));
                                    resolve(docs.rows);
                                    if (docs.rows.length > 0) {
                                        callback.onSuccess(docs.rows);
                                    }
                                    else {
                                        if (callback.onEmpty) {
                                            callback.onEmpty();
                                        }
                                    }
                                    return [3 /*break*/, 3];
                                case 2:
                                    e_1 = _a.sent();
                                    callback.onError(e_1);
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); }));
                };
                /**
                 * @return {?}
                 */
                class_1.prototype.getDocsInPromise = /**
                 * @return {?}
                 */
                function () {
                    var _this = this;
                    return new Promise((/**
                     * @param {?} resolve
                     * @return {?}
                     */
                    function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                        var docs;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.database.allDocs({
                                        include_docs: true,
                                        attachments: true
                                    })];
                                case 1:
                                    docs = _a.sent();
                                    docs.rows = docs.rows.map((/**
                                     * @param {?} item
                                     * @return {?}
                                     */
                                    function (item) {
                                        return item.doc;
                                    }));
                                    resolve(docs.rows);
                                    return [2 /*return*/, docs.rows];
                            }
                        });
                    }); }));
                };
                /**
                 * @param {?} url
                 * @param {?=} options
                 * @return {?}
                 */
                class_1.prototype.syncWith = /**
                 * @param {?} url
                 * @param {?=} options
                 * @return {?}
                 */
                function (url, options) {
                    this.sync = this.database.sync(new PouchDB(url), (!options) ? {
                        live: true,
                        retry: true
                    } : options);
                    return this.sync;
                };
                /**
                 * @param {?} url
                 * @param {?=} options
                 * @return {?}
                 */
                class_1.prototype.replicateTo = /**
                 * @param {?} url
                 * @param {?=} options
                 * @return {?}
                 */
                function (url, options) {
                    this.replication = this.database.replicate.to(new PouchDB(url), (!options) ? {
                        live: true,
                        retry: true
                    } : options);
                    return this.replication;
                };
                /**
                 * @param {?} url
                 * @param {?=} options
                 * @return {?}
                 */
                class_1.prototype.replicateFrom = /**
                 * @param {?} url
                 * @param {?=} options
                 * @return {?}
                 */
                function (url, options) {
                    this.replication = this.database.replicate.from(new PouchDB(url), (!options) ? {
                        live: true,
                        retry: true
                    } : options);
                    return this.replication;
                };
                /**
                 * @return {?}
                 */
                class_1.prototype.getAttachementManager = /**
                 * @return {?}
                 */
                function () {
                    return new AttachementManager(this.database);
                };
                /**
                 * @param {?} data
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.put = /**
                 * @param {?} data
                 * @param {?=} callback
                 * @return {?}
                 */
                function (data, callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var promise, e_2;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!!this.isFromBase) return [3 /*break*/, 8];
                                    promise = void 0;
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 6, , 7]);
                                    if (!(data instanceof Array)) return [3 /*break*/, 3];
                                    return [4 /*yield*/, this.database.bulkDocs(data)];
                                case 2:
                                    promise = _a.sent();
                                    return [3 /*break*/, 5];
                                case 3: return [4 /*yield*/, this.database.put(data)];
                                case 4:
                                    promise = _a.sent();
                                    _a.label = 5;
                                case 5: return [2 /*return*/, (promise)];
                                case 6:
                                    e_2 = _a.sent();
                                    console.error(e_2);
                                    return [3 /*break*/, 7];
                                case 7: return [2 /*return*/];
                                case 8:
                                    this.putBaseMode(data, callback);
                                    _a.label = 9;
                                case 9: return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?} data
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.putBaseMode = /**
                 * @param {?} data
                 * @param {?=} callback
                 * @return {?}
                 */
                function (data, callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var promise, e_3;
                        var _this = this;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 5, , 6]);
                                    if (!(data instanceof Array)) return [3 /*break*/, 2];
                                    data = data.map((/**
                                     * @param {?} item
                                     * @return {?}
                                     */
                                    function (item) {
                                        Object.assign(item, { table: _this.tableName });
                                        return item;
                                    }));
                                    return [4 /*yield*/, this.database.bulkDocs(data)];
                                case 1:
                                    promise = _a.sent();
                                    return [3 /*break*/, 4];
                                case 2:
                                    Object.assign(data, { table: this.tableName });
                                    return [4 /*yield*/, this.database.put(data)];
                                case 3:
                                    promise = _a.sent();
                                    _a.label = 4;
                                case 4: return [2 /*return*/, (promise)];
                                case 5:
                                    e_3 = _a.sent();
                                    console.error(e_3);
                                    return [3 /*break*/, 6];
                                case 6: return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?} doc
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.delete = /**
                 * @param {?} doc
                 * @param {?=} callback
                 * @return {?}
                 */
                function (doc, callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!!callback) return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.database.remove(doc)];
                                case 1: return [2 /*return*/, _a.sent()];
                                case 2:
                                    this.deleteWithCallBack(doc, callback);
                                    return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?} value
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.update = /**
                 * @param {?} value
                 * @param {?=} callback
                 * @return {?}
                 */
                function (value, callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var target;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.apply()];
                                case 1:
                                    target = _a.sent();
                                    console.log('raada', target);
                                    target.forEach((/**
                                     * @param {?} item
                                     * @return {?}
                                     */
                                    function (item) {
                                        Object.assign(item, value);
                                    }));
                                    if (!!callback) return [3 /*break*/, 3];
                                    return [4 /*yield*/, this.put(target)];
                                case 2: return [2 /*return*/, _a.sent()];
                                case 3:
                                    this.put(target, callback);
                                    _a.label = 4;
                                case 4: return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?} newObjects
                 * @return {?}
                 */
                class_1.prototype.set = /**
                 * @param {?} newObjects
                 * @return {?}
                 */
                function (newObjects) {
                    return __awaiter(this, void 0, void 0, function () {
                        var item, result, _a, _b, _c, _d, e_4_1;
                        var e_4, _e;
                        return __generator(this, function (_f) {
                            switch (_f.label) {
                                case 0:
                                    result = [];
                                    _f.label = 1;
                                case 1:
                                    _f.trys.push([1, 6, 7, 8]);
                                    _a = __values(this.whereRes), _b = _a.next();
                                    _f.label = 2;
                                case 2:
                                    if (!!_b.done) return [3 /*break*/, 5];
                                    item = _b.value;
                                    Object.assign(item, newObjects);
                                    _d = (_c = result).push;
                                    return [4 /*yield*/, this.database.put(item)];
                                case 3:
                                    _d.apply(_c, [_f.sent()]);
                                    _f.label = 4;
                                case 4:
                                    _b = _a.next();
                                    return [3 /*break*/, 2];
                                case 5: return [3 /*break*/, 8];
                                case 6:
                                    e_4_1 = _f.sent();
                                    e_4 = { error: e_4_1 };
                                    return [3 /*break*/, 8];
                                case 7:
                                    try {
                                        if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                                    }
                                    finally { if (e_4) throw e_4.error; }
                                    return [7 /*endfinally*/];
                                case 8: return [2 /*return*/, result];
                            }
                        });
                    });
                };
                /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.deleteWhereWithCallBack = /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @param {?=} callback
                 * @return {?}
                 */
                function (field, value, operator, callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var result, toDelete, toDelete_1, toDelete_1_1, item, _a, _b, e_5_1, e_6;
                        var e_5, _c;
                        return __generator(this, function (_d) {
                            switch (_d.label) {
                                case 0:
                                    if (callback.onPreExecute) {
                                        callback.onPreExecute();
                                    }
                                    return [4 /*yield*/, this.where(field, value, operator).apply()];
                                case 1:
                                    toDelete = _d.sent();
                                    result = [];
                                    _d.label = 2;
                                case 2:
                                    _d.trys.push([2, 11, , 12]);
                                    _d.label = 3;
                                case 3:
                                    _d.trys.push([3, 8, 9, 10]);
                                    toDelete_1 = __values(toDelete), toDelete_1_1 = toDelete_1.next();
                                    _d.label = 4;
                                case 4:
                                    if (!!toDelete_1_1.done) return [3 /*break*/, 7];
                                    item = toDelete_1_1.value;
                                    item[field] = value;
                                    _b = (_a = result).push;
                                    return [4 /*yield*/, this.delete(item)];
                                case 5:
                                    _b.apply(_a, [_d.sent()]);
                                    _d.label = 6;
                                case 6:
                                    toDelete_1_1 = toDelete_1.next();
                                    return [3 /*break*/, 4];
                                case 7: return [3 /*break*/, 10];
                                case 8:
                                    e_5_1 = _d.sent();
                                    e_5 = { error: e_5_1 };
                                    return [3 /*break*/, 10];
                                case 9:
                                    try {
                                        if (toDelete_1_1 && !toDelete_1_1.done && (_c = toDelete_1.return)) _c.call(toDelete_1);
                                    }
                                    finally { if (e_5) throw e_5.error; }
                                    return [7 /*endfinally*/];
                                case 10:
                                    callback.onSuccess(result);
                                    return [3 /*break*/, 12];
                                case 11:
                                    e_6 = _d.sent();
                                    callback.onError(e_6);
                                    return [3 /*break*/, 12];
                                case 12:
                                    if (callback.onPostExecute) {
                                        callback.onPostExecute();
                                    }
                                    return [2 /*return*/, result];
                            }
                        });
                    });
                };
                /**
                 * @template THIS
                 * @this {THIS}
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @return {THIS}
                 */
                class_1.prototype.where = /**
                 * @template THIS
                 * @this {THIS}
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @return {THIS}
                 */
                function (field, value, operator) {
                    Object.assign((/** @type {?} */ (this)).query.selector, (/** @type {?} */ (this)).buildWhereClause(field, value, operator));
                    return (/** @type {?} */ (this));
                };
                /**
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.first = /**
                 * @param {?=} callback
                 * @return {?}
                 */
                function (callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var result;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!!this.isFromBase) return [3 /*break*/, 4];
                                    if (!!callback) return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.database.find(this.query)];
                                case 1:
                                    result = _a.sent();
                                    return [2 /*return*/, result.docs[0]];
                                case 2: return [4 /*yield*/, this.applyWithCallBack(callback, true)];
                                case 3:
                                    _a.sent();
                                    return [2 /*return*/];
                                case 4:
                                    this.where('table', this.tableName);
                                    if (!!callback) return [3 /*break*/, 6];
                                    return [4 /*yield*/, this.database.find(this.query)];
                                case 5:
                                    result = _a.sent();
                                    return [2 /*return*/, result.docs[0]];
                                case 6:
                                    this.applyWithCallBack(callback, true);
                                    return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.apply = /**
                 * @param {?=} callback
                 * @return {?}
                 */
                function (callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var result;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (this.isFromBase) {
                                        this.where('table', this.tableName, '=');
                                    }
                                    if (!!callback) return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.database.find(this.query)];
                                case 1:
                                    result = _a.sent();
                                    return [2 /*return*/, result.docs];
                                case 2: return [4 /*yield*/, this.applyWithCallBack(callback, false)];
                                case 3:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?} callback
                 * @param {?} isFirst
                 * @return {?}
                 */
                class_1.prototype.applyWithCallBack = /**
                 * @param {?} callback
                 * @param {?} isFirst
                 * @return {?}
                 */
                function (callback, isFirst) {
                    return __awaiter(this, void 0, void 0, function () {
                        var result_1, result;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!!this.isFromBase) return [3 /*break*/, 2];
                                    if (callback.onPreExecute) {
                                        callback.onPreExecute();
                                    }
                                    return [4 /*yield*/, this.get()];
                                case 1:
                                    result_1 = _a.sent();
                                    if (result_1.docs.length > 0) {
                                        if (isFirst) {
                                            callback.onSuccess(result_1.docs[0]);
                                        }
                                        else {
                                            callback.onSuccess(result_1.docs);
                                        }
                                    }
                                    else {
                                        if (callback.onEmpty) {
                                            callback.onEmpty();
                                        }
                                    }
                                    if (callback.onPostExecute) {
                                        callback.onPostExecute();
                                    }
                                    return [2 /*return*/, result_1];
                                case 2:
                                    if (callback.onPreExecute) {
                                        callback.onPreExecute();
                                    }
                                    return [4 /*yield*/, this.database.find(this.query)];
                                case 3:
                                    result = _a.sent();
                                    if (result.docs.length > 0) {
                                        if (isFirst) {
                                            callback.onSuccess(result.docs[0]);
                                        }
                                        else {
                                            callback.onSuccess(result.docs);
                                        }
                                    }
                                    else {
                                        if (callback.onEmpty) {
                                            callback.onEmpty();
                                        }
                                    }
                                    if (callback.onPostExecute) {
                                        callback.onPostExecute();
                                    }
                                    return [2 /*return*/, result];
                            }
                        });
                    });
                };
                /**
                 * @param {?} field
                 * @param {?=} order
                 * @return {?}
                 */
                class_1.prototype.orderBy = /**
                 * @param {?} field
                 * @param {?=} order
                 * @return {?}
                 */
                function (field, order) {
                    this.query.sort = this.buildOrderByClause(field, order);
                    return this;
                };
                /**
                 * @param {?} fields
                 * @return {?}
                 */
                class_1.prototype.select = /**
                 * @param {?} fields
                 * @return {?}
                 */
                function (fields) {
                    this.query.fields = fields;
                    return this;
                };
                /**
                 * @param {?} limit
                 * @return {?}
                 */
                class_1.prototype.limit = /**
                 * @param {?} limit
                 * @return {?}
                 */
                function (limit) {
                    this.query.limit = limit;
                    return this;
                };
                /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @param {?=} callback
                 * @return {?}
                 */
                class_1.prototype.deleteWhere = /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @param {?=} callback
                 * @return {?}
                 */
                function (field, value, operator, callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!!callback) return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.deleteWhereAndGetResult(field, value, operator)];
                                case 1: return [2 /*return*/, _a.sent()];
                                case 2:
                                    this.deleteWhereWithCallBack(field, value, operator, callback);
                                    return [2 /*return*/];
                            }
                        });
                    });
                };
                /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?} operator
                 * @return {?}
                 */
                class_1.prototype.deleteWhereAndGetResult = /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?} operator
                 * @return {?}
                 */
                function (field, value, operator) {
                    return __awaiter(this, void 0, void 0, function () {
                        var toDeleteList, result, toDeleteList_1, toDeleteList_1_1, item;
                        var e_7, _a;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0: return [4 /*yield*/, this.where(field, value, operator).apply()];
                                case 1:
                                    toDeleteList = _b.sent();
                                    result = [];
                                    try {
                                        for (toDeleteList_1 = __values(toDeleteList), toDeleteList_1_1 = toDeleteList_1.next(); !toDeleteList_1_1.done; toDeleteList_1_1 = toDeleteList_1.next()) {
                                            item = toDeleteList_1_1.value;
                                            result.push(this.delete(item));
                                        }
                                    }
                                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                                    finally {
                                        try {
                                            if (toDeleteList_1_1 && !toDeleteList_1_1.done && (_a = toDeleteList_1.return)) _a.call(toDeleteList_1);
                                        }
                                        finally { if (e_7) throw e_7.error; }
                                    }
                                    return [4 /*yield*/, Promise.all(result)];
                                case 2: return [2 /*return*/, _b.sent()];
                            }
                        });
                    });
                };
                /**
                 * @param {?} field
                 * @param {?=} order
                 * @return {?}
                 */
                class_1.prototype.buildOrderByClause = /**
                 * @param {?} field
                 * @param {?=} order
                 * @return {?}
                 */
                function (field, order) {
                    /** @type {?} */
                    var result = {};
                    result[field] = (order) ? order : 'asc';
                    return JSON.parse(JSON.stringify([result]));
                };
                /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @return {?}
                 */
                class_1.prototype.buildWhereClause = /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @return {?}
                 */
                function (field, value, operator) {
                    /** @type {?} */
                    var result = {};
                    result[field] = (operator) ? OperatorHelper.getValueWithOperator(operator, value) : OperatorHelper.getEqualOperator(value);
                    return JSON.parse(JSON.stringify(result));
                };
                /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @return {?}
                 */
                class_1.prototype.orWhere = /**
                 * @param {?} field
                 * @param {?} value
                 * @param {?=} operator
                 * @return {?}
                 */
                function (field, value, operator) {
                    this.query.selector = {
                        $or: [this.query.selector, this.buildWhereClause(field, value, operator)]
                    };
                    return this;
                };
                /**
                 * @param {?} doc
                 * @param {?} callback
                 * @return {?}
                 */
                class_1.prototype.deleteWithCallBack = /**
                 * @param {?} doc
                 * @param {?} callback
                 * @return {?}
                 */
                function (doc, callback) {
                    return __awaiter(this, void 0, void 0, function () {
                        var _a, _b, e_8;
                        return __generator(this, function (_c) {
                            switch (_c.label) {
                                case 0:
                                    if (callback.onPreExecute) {
                                        callback.onPreExecute();
                                    }
                                    _c.label = 1;
                                case 1:
                                    _c.trys.push([1, 3, , 4]);
                                    _b = (_a = callback).onSuccess;
                                    return [4 /*yield*/, this.database.remove(doc)];
                                case 2:
                                    _b.apply(_a, [_c.sent()]);
                                    return [3 /*break*/, 4];
                                case 3:
                                    e_8 = _c.sent();
                                    callback.onError(e_8);
                                    return [3 /*break*/, 4];
                                case 4:
                                    if (callback.onPostExecute) {
                                        callback.onPostExecute();
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    });
                };
                return class_1;
            }(constructor));
        });
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/entity.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} name
     * @return {?}
     */
    function Entity(name) {
        return (/**
         * @template T
         * @param {?} constructor
         * @return {?}
         */
        function (constructor) {
            PouchDB.plugin(PouchdbFind);
            /** @type {?} */
            var db;
            /** @type {?} */
            var chosenName = name ? name : constructor.name;
            if ((Object.getPrototypeOf(constructor) + '').includes('BaseEntity')) {
                //  DbManager.getInstance().getBaseDb();
            }
            else {
                if (DbManager.getInstance().getDBByName(chosenName) == null) {
                    db = new PouchDB(chosenName);
                    DbManager.getInstance().addDB({
                        name: chosenName,
                        db: db
                    });
                }
            }
            return constructor;
        });
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/base/i.dao.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    IDao = /** @class */ (function () {
        function IDao() {
        }
        return IDao;
    }());
    if (false) {
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.get = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.put = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.delete = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.select = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.where = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.orderBy = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.limit = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.apply = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.first = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.sync = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.deleteWhere = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.update = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.set = function (args) { };
        /**
         * @abstract
         * @param {...?} args
         * @return {?}
         */
        IDao.prototype.orWhere = function (args) { };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/base/i.callback.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function ICallback() { }
    if (false) {
        /** @type {?|undefined} */
        ICallback.prototype.onPreExecute;
        /** @type {?} */
        ICallback.prototype.onSuccess;
        /** @type {?} */
        ICallback.prototype.onError;
        /** @type {?|undefined} */
        ICallback.prototype.onEmpty;
        /** @type {?|undefined} */
        ICallback.prototype.onPostExecute;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/attachment/models/attachement.model.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AttachementModel = /** @class */ (function () {
        function AttachementModel() {
        }
        return AttachementModel;
    }());
    if (false) {
        /** @type {?} */
        AttachementModel.prototype.docId;
        /** @type {?} */
        AttachementModel.prototype.attachmentId;
        /** @type {?} */
        AttachementModel.prototype.rev;
        /** @type {?} */
        AttachementModel.prototype.content;
        /** @type {?} */
        AttachementModel.prototype.type;
        /** @type {?} */
        AttachementModel.prototype.callback;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/attachment/types.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AttachmentTypes = /** @class */ (function () {
        function AttachmentTypes() {
        }
        AttachmentTypes.JPG = 'image/jpg';
        AttachmentTypes.PNG = 'image/png';
        AttachmentTypes.TEXT = 'text/plain';
        AttachmentTypes.OCTETSTREAM = 'application/octet-stream';
        return AttachmentTypes;
    }());
    if (false) {
        /** @type {?} */
        AttachmentTypes.JPG;
        /** @type {?} */
        AttachmentTypes.PNG;
        /** @type {?} */
        AttachmentTypes.TEXT;
        /** @type {?} */
        AttachmentTypes.OCTETSTREAM;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/base/BaseEntity.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BaseEntity = /** @class */ (function () {
        function BaseEntity() {
            this.baseEntity = '';
        }
        return BaseEntity;
    }());
    if (false) {
        /** @type {?} */
        BaseEntity.prototype.baseEntity;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/master.doa.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    PouchDB.plugin(PouchdbFind);
    var MasterDoa = /** @class */ (function () {
        function MasterDoa(database) {
            this.query = { selector: {} };
            PouchDB.plugin(PouchdbFind);
            this.database = database;
        }
        /**
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.get = /**
         * @param {?=} callback
         * @return {?}
         */
        function (callback) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!callback) {
                                return [2 /*return*/, this.getDocsInPromise()];
                            }
                            if (callback.onPreExecute) {
                                callback.onPreExecute();
                            }
                            return [4 /*yield*/, this.getDocsWithCallBack(callback)];
                        case 1:
                            _a.sent();
                            if (callback.onPostExecute) {
                                callback.onPostExecute();
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        MasterDoa.prototype.getDocsWithCallBack = /**
         * @param {?} callback
         * @return {?}
         */
        function (callback) {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                var docs, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.database.allDocs({
                                    include_docs: true,
                                    attachments: true
                                })];
                        case 1:
                            docs = _a.sent();
                            docs.rows = docs.rows.map((/**
                             * @param {?} item
                             * @return {?}
                             */
                            function (item) {
                                return item.doc;
                            }));
                            resolve(docs.rows);
                            if (docs.rows.length > 0) {
                                callback.onSuccess(docs.rows);
                            }
                            else {
                                if (callback.onEmpty) {
                                    callback.onEmpty();
                                }
                            }
                            return [3 /*break*/, 3];
                        case 2:
                            e_1 = _a.sent();
                            callback.onError(e_1);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            }); }));
        };
        /**
         * @return {?}
         */
        MasterDoa.prototype.getDocsInPromise = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                var docs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.database.allDocs({
                                include_docs: true,
                                attachments: true
                            })];
                        case 1:
                            docs = _a.sent();
                            docs.rows = docs.rows.map((/**
                             * @param {?} item
                             * @return {?}
                             */
                            function (item) {
                                return item.doc;
                            }));
                            resolve(docs.rows);
                            return [2 /*return*/, docs.rows];
                    }
                });
            }); }));
        };
        /**
         * @param {?} data
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.put = /**
         * @param {?} data
         * @param {?=} callback
         * @return {?}
         */
        function (data, callback) {
            return __awaiter(this, void 0, void 0, function () {
                var promise, e_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 5, , 6]);
                            if (!(data instanceof Array)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.database.bulkDocs(data)];
                        case 1:
                            promise = _a.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, this.database.put(data)];
                        case 3:
                            promise = _a.sent();
                            _a.label = 4;
                        case 4: return [2 /*return*/, (promise)];
                        case 5:
                            e_2 = _a.sent();
                            console.error(e_2);
                            return [3 /*break*/, 6];
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?} doc
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.delete = /**
         * @param {?} doc
         * @param {?=} callback
         * @return {?}
         */
        function (doc, callback) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!callback) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.database.remove(doc)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2:
                            this.deleteWithCallBack(doc, callback);
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.updateWhere = /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        function (field, value, operator, callback) {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!!callback) return [3 /*break*/, 2];
                            _a = this;
                            return [4 /*yield*/, this.where(field, value, operator).apply()];
                        case 1:
                            _a.whereRes = _b.sent();
                            _b.label = 2;
                        case 2: 
                        //  this.updateWithCallBack(field, value, operator, callback);
                        return [2 /*return*/, this];
                    }
                });
            });
        };
        /**
         * @param {?} newObjects
         * @return {?}
         */
        MasterDoa.prototype.set = /**
         * @param {?} newObjects
         * @return {?}
         */
        function (newObjects) {
            return __awaiter(this, void 0, void 0, function () {
                var item, result, _a, _b, _c, _d, e_3_1;
                var e_3, _e;
                return __generator(this, function (_f) {
                    switch (_f.label) {
                        case 0:
                            result = [];
                            _f.label = 1;
                        case 1:
                            _f.trys.push([1, 6, 7, 8]);
                            _a = __values(this.whereRes), _b = _a.next();
                            _f.label = 2;
                        case 2:
                            if (!!_b.done) return [3 /*break*/, 5];
                            item = _b.value;
                            Object.assign(item, newObjects);
                            _d = (_c = result).push;
                            return [4 /*yield*/, this.database.put(item)];
                        case 3:
                            _d.apply(_c, [_f.sent()]);
                            _f.label = 4;
                        case 4:
                            _b = _a.next();
                            return [3 /*break*/, 2];
                        case 5: return [3 /*break*/, 8];
                        case 6:
                            e_3_1 = _f.sent();
                            e_3 = { error: e_3_1 };
                            return [3 /*break*/, 8];
                        case 7:
                            try {
                                if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                            }
                            finally { if (e_3) throw e_3.error; }
                            return [7 /*endfinally*/];
                        case 8: return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.updateWithCallBack = /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        function (field, value, operator, callback) {
            return __awaiter(this, void 0, void 0, function () {
                var item, result, toUpdate, toUpdate_1, toUpdate_1_1, _a, _b, e_4_1, e_5;
                var e_4, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (callback.onPreExecute) {
                                callback.onPreExecute();
                            }
                            return [4 /*yield*/, this.where(field, value, operator).apply()];
                        case 1:
                            toUpdate = _d.sent();
                            result = [];
                            _d.label = 2;
                        case 2:
                            _d.trys.push([2, 11, , 12]);
                            _d.label = 3;
                        case 3:
                            _d.trys.push([3, 8, 9, 10]);
                            toUpdate_1 = __values(toUpdate), toUpdate_1_1 = toUpdate_1.next();
                            _d.label = 4;
                        case 4:
                            if (!!toUpdate_1_1.done) return [3 /*break*/, 7];
                            item = toUpdate_1_1.value;
                            item[field] = value;
                            _b = (_a = result).push;
                            return [4 /*yield*/, this.database.put(item)];
                        case 5:
                            _b.apply(_a, [_d.sent()]);
                            _d.label = 6;
                        case 6:
                            toUpdate_1_1 = toUpdate_1.next();
                            return [3 /*break*/, 4];
                        case 7: return [3 /*break*/, 10];
                        case 8:
                            e_4_1 = _d.sent();
                            e_4 = { error: e_4_1 };
                            return [3 /*break*/, 10];
                        case 9:
                            try {
                                if (toUpdate_1_1 && !toUpdate_1_1.done && (_c = toUpdate_1.return)) _c.call(toUpdate_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                            return [7 /*endfinally*/];
                        case 10:
                            callback.onSuccess(result);
                            return [3 /*break*/, 12];
                        case 11:
                            e_5 = _d.sent();
                            callback.onError(e_5);
                            return [3 /*break*/, 12];
                        case 12:
                            if (callback.onPostExecute) {
                                callback.onPostExecute();
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.deleteWhereWithCallBack = /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        function (field, value, operator, callback) {
            return __awaiter(this, void 0, void 0, function () {
                var result, toDelete, toDelete_1, toDelete_1_1, item, _a, _b, e_6_1, e_7;
                var e_6, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (callback.onPreExecute) {
                                callback.onPreExecute();
                            }
                            return [4 /*yield*/, this.where(field, value, operator).apply()];
                        case 1:
                            toDelete = _d.sent();
                            result = [];
                            _d.label = 2;
                        case 2:
                            _d.trys.push([2, 11, , 12]);
                            _d.label = 3;
                        case 3:
                            _d.trys.push([3, 8, 9, 10]);
                            toDelete_1 = __values(toDelete), toDelete_1_1 = toDelete_1.next();
                            _d.label = 4;
                        case 4:
                            if (!!toDelete_1_1.done) return [3 /*break*/, 7];
                            item = toDelete_1_1.value;
                            item[field] = value;
                            _b = (_a = result).push;
                            return [4 /*yield*/, this.delete(item)];
                        case 5:
                            _b.apply(_a, [_d.sent()]);
                            _d.label = 6;
                        case 6:
                            toDelete_1_1 = toDelete_1.next();
                            return [3 /*break*/, 4];
                        case 7: return [3 /*break*/, 10];
                        case 8:
                            e_6_1 = _d.sent();
                            e_6 = { error: e_6_1 };
                            return [3 /*break*/, 10];
                        case 9:
                            try {
                                if (toDelete_1_1 && !toDelete_1_1.done && (_c = toDelete_1.return)) _c.call(toDelete_1);
                            }
                            finally { if (e_6) throw e_6.error; }
                            return [7 /*endfinally*/];
                        case 10:
                            callback.onSuccess(result);
                            return [3 /*break*/, 12];
                        case 11:
                            e_7 = _d.sent();
                            callback.onError(e_7);
                            return [3 /*break*/, 12];
                        case 12:
                            if (callback.onPostExecute) {
                                callback.onPostExecute();
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * @param {?} toUpdate
         * @param {?} newData
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        MasterDoa.prototype.updateAndGetResult = /**
         * @param {?} toUpdate
         * @param {?} newData
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (toUpdate, newData, field, value) {
            return __awaiter(this, void 0, void 0, function () {
                var item, result, toUpdate_2, toUpdate_2_1, _a, _b, e_8_1;
                var e_8, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            result = [];
                            _d.label = 1;
                        case 1:
                            _d.trys.push([1, 6, 7, 8]);
                            toUpdate_2 = __values(toUpdate), toUpdate_2_1 = toUpdate_2.next();
                            _d.label = 2;
                        case 2:
                            if (!!toUpdate_2_1.done) return [3 /*break*/, 5];
                            item = toUpdate_2_1.value;
                            item[field] = newData;
                            _b = (_a = result).push;
                            return [4 /*yield*/, this.database.put(item)];
                        case 3:
                            _b.apply(_a, [_d.sent()]);
                            _d.label = 4;
                        case 4:
                            toUpdate_2_1 = toUpdate_2.next();
                            return [3 /*break*/, 2];
                        case 5: return [3 /*break*/, 8];
                        case 6:
                            e_8_1 = _d.sent();
                            e_8 = { error: e_8_1 };
                            return [3 /*break*/, 8];
                        case 7:
                            try {
                                if (toUpdate_2_1 && !toUpdate_2_1.done && (_c = toUpdate_2.return)) _c.call(toUpdate_2);
                            }
                            finally { if (e_8) throw e_8.error; }
                            return [7 /*endfinally*/];
                        case 8: return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * @template THIS
         * @this {THIS}
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @return {THIS}
         */
        MasterDoa.prototype.where = /**
         * @template THIS
         * @this {THIS}
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @return {THIS}
         */
        function (field, value, operator) {
            Object.assign((/** @type {?} */ (this)).query.selector, (/** @type {?} */ (this)).buildWhereClause(field, value, operator));
            return (/** @type {?} */ (this));
        };
        /**
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.first = /**
         * @param {?=} callback
         * @return {?}
         */
        function (callback) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!callback) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.database.find(this.query)];
                        case 1:
                            result = _a.sent();
                            return [2 /*return*/, result.docs[0]];
                        case 2: return [4 /*yield*/, this.applyWithCallBack(callback, true)];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.apply = /**
         * @param {?=} callback
         * @return {?}
         */
        function (callback) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!callback) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.database.find(this.query)];
                        case 1:
                            result = _a.sent();
                            return [2 /*return*/, result.docs];
                        case 2: return [4 /*yield*/, this.applyWithCallBack(callback, false)];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?} callback
         * @param {?} isFirst
         * @return {?}
         */
        MasterDoa.prototype.applyWithCallBack = /**
         * @param {?} callback
         * @param {?} isFirst
         * @return {?}
         */
        function (callback, isFirst) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (callback.onPreExecute) {
                                callback.onPreExecute();
                            }
                            return [4 /*yield*/, this.database.find(this.query)];
                        case 1:
                            result = _a.sent();
                            if (result.docs.length > 0) {
                                if (isFirst) {
                                    callback.onSuccess(result.docs[0]);
                                }
                                else {
                                    callback.onSuccess(result.docs);
                                }
                            }
                            else {
                                if (callback.onEmpty) {
                                    callback.onEmpty();
                                }
                            }
                            if (callback.onPostExecute) {
                                callback.onPostExecute();
                            }
                            return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * @param {?} field
         * @param {?=} order
         * @return {?}
         */
        MasterDoa.prototype.orderBy = /**
         * @param {?} field
         * @param {?=} order
         * @return {?}
         */
        function (field, order) {
            this.query.sort = this.buildOrderByClause(field, order);
            return this;
        };
        /**
         * @param {?} fields
         * @return {?}
         */
        MasterDoa.prototype.select = /**
         * @param {?} fields
         * @return {?}
         */
        function (fields) {
            this.query.fields = fields;
            return this;
        };
        /**
         * @param {?} limit
         * @return {?}
         */
        MasterDoa.prototype.limit = /**
         * @param {?} limit
         * @return {?}
         */
        function (limit) {
            this.query.limit = limit;
            return this;
        };
        /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.deleteWhere = /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @param {?=} callback
         * @return {?}
         */
        function (field, value, operator, callback) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!callback) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.deleteWhereAndGetResult(field, value, operator)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2:
                            this.deleteWhereWithCallBack(field, value, operator, callback);
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @param {?} field
         * @param {?} value
         * @param {?} operator
         * @return {?}
         */
        MasterDoa.prototype.deleteWhereAndGetResult = /**
         * @param {?} field
         * @param {?} value
         * @param {?} operator
         * @return {?}
         */
        function (field, value, operator) {
            return __awaiter(this, void 0, void 0, function () {
                var toDeleteList, result, toDeleteList_1, toDeleteList_1_1, item, _a, _b, e_9_1;
                var e_9, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0: return [4 /*yield*/, this.where(field, value, operator).apply()];
                        case 1:
                            toDeleteList = _d.sent();
                            result = [];
                            _d.label = 2;
                        case 2:
                            _d.trys.push([2, 7, 8, 9]);
                            toDeleteList_1 = __values(toDeleteList), toDeleteList_1_1 = toDeleteList_1.next();
                            _d.label = 3;
                        case 3:
                            if (!!toDeleteList_1_1.done) return [3 /*break*/, 6];
                            item = toDeleteList_1_1.value;
                            _b = (_a = result).push;
                            return [4 /*yield*/, this.delete(item)];
                        case 4:
                            _b.apply(_a, [_d.sent()]);
                            _d.label = 5;
                        case 5:
                            toDeleteList_1_1 = toDeleteList_1.next();
                            return [3 /*break*/, 3];
                        case 6: return [3 /*break*/, 9];
                        case 7:
                            e_9_1 = _d.sent();
                            e_9 = { error: e_9_1 };
                            return [3 /*break*/, 9];
                        case 8:
                            try {
                                if (toDeleteList_1_1 && !toDeleteList_1_1.done && (_c = toDeleteList_1.return)) _c.call(toDeleteList_1);
                            }
                            finally { if (e_9) throw e_9.error; }
                            return [7 /*endfinally*/];
                        case 9: return [2 /*return*/, result];
                    }
                });
            });
        };
        /**
         * @param {?} value
         * @param {?=} callback
         * @return {?}
         */
        MasterDoa.prototype.update = /**
         * @param {?} value
         * @param {?=} callback
         * @return {?}
         */
        function (value, callback) {
            return __awaiter(this, void 0, void 0, function () {
                var target;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.apply()];
                        case 1:
                            target = _a.sent();
                            if (!callback) {
                                target = target.map((/**
                                 * @param {?} item
                                 * @return {?}
                                 */
                                function (item) {
                                    return Object.assign(item, value);
                                }));
                            }
                            return [4 /*yield*/, this.put(target)];
                        case 2: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * @param {?} field
         * @param {?=} order
         * @return {?}
         */
        MasterDoa.prototype.buildOrderByClause = /**
         * @param {?} field
         * @param {?=} order
         * @return {?}
         */
        function (field, order) {
            /** @type {?} */
            var result = {};
            result[field] = (order) ? order : 'asc';
            return JSON.parse(JSON.stringify([result]));
        };
        /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @return {?}
         */
        MasterDoa.prototype.buildWhereClause = /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @return {?}
         */
        function (field, value, operator) {
            /** @type {?} */
            var result = {};
            result[field] = (operator) ? OperatorHelper.getValueWithOperator(operator, value) : OperatorHelper.getEqualOperator(value);
            return JSON.parse(JSON.stringify(result));
        };
        /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @return {?}
         */
        MasterDoa.prototype.orWhere = /**
         * @param {?} field
         * @param {?} value
         * @param {?=} operator
         * @return {?}
         */
        function (field, value, operator) {
            this.query.selector = {
                $or: [this.query.selector, this.buildWhereClause(field, value, operator)]
            };
            return this;
        };
        /**
         * @param {?} doc
         * @param {?} callback
         * @return {?}
         */
        MasterDoa.prototype.deleteWithCallBack = /**
         * @param {?} doc
         * @param {?} callback
         * @return {?}
         */
        function (doc, callback) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b, e_10;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            if (callback.onPreExecute) {
                                callback.onPreExecute();
                            }
                            _c.label = 1;
                        case 1:
                            _c.trys.push([1, 3, , 4]);
                            _b = (_a = callback).onSuccess;
                            return [4 /*yield*/, this.database.remove(doc)];
                        case 2:
                            _b.apply(_a, [_c.sent()]);
                            return [3 /*break*/, 4];
                        case 3:
                            e_10 = _c.sent();
                            callback.onError(e_10);
                            return [3 /*break*/, 4];
                        case 4:
                            if (callback.onPostExecute) {
                                callback.onPostExecute();
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        return MasterDoa;
    }());
    if (false) {
        /** @type {?} */
        MasterDoa.prototype.tableName;
        /** @type {?} */
        MasterDoa.prototype.database;
        /** @type {?} */
        MasterDoa.prototype.query;
        /** @type {?} */
        MasterDoa.prototype.sync;
        /** @type {?} */
        MasterDoa.prototype.whereRes;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/asorm.db.confing.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    PouchDB.plugin(PouchdbFind);
    var AsormConfig = /** @class */ (function () {
        function AsormConfig(config) {
            try {
                this.url = config.url;
                this.dbName = config.dbName;
                localStorage.setItem(ConstantsHelper.CONFIG_KEY, JSON.stringify(config));
                /** @type {?} */
                var pouchOpts = (config.username && config.password) ? {
                    skipSetup: true,
                    ajax: {
                        cache: false,
                        timeout: 30000
                    },
                    auth: {
                        username: config.username,
                        password: config.password,
                    }
                } :
                    {
                        skipSetup: true
                    };
                this.remote = new PouchDB(this.url
                    + '/' + this.dbName, pouchOpts);
                DbManager.getInstance().getBaseDb().database = DbManager.getInstance().getBaseDb().db;
            }
            catch (err) {
                console.log(err);
            }
        }
        /**
         * @param {?=} options
         * @return {?}
         */
        AsormConfig.prototype.synchronize = /**
         * @param {?=} options
         * @return {?}
         */
        function (options) {
            try {
                if (DbManager.getInstance().getBaseDb().database) {
                    this.sync = DbManager.getInstance().getBaseDb().database.sync(this.remote, (!options) ? {
                        live: true,
                        retry: true
                    } : options);
                    return this.sync;
                }
            }
            catch (e) {
                console.log('error', e);
            }
        };
        /**
         * @return {?}
         */
        AsormConfig.prototype.getMasterDao = /**
         * @return {?}
         */
        function () {
            if (this.masterDao === undefined) {
                this.masterDao = new MasterDoa(DbManager.getInstance().getBaseDb().db);
            }
            return this.masterDao;
        };
        return AsormConfig;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AsormConfig.prototype.sync;
        /**
         * @type {?}
         * @private
         */
        AsormConfig.prototype.url;
        /**
         * @type {?}
         * @private
         */
        AsormConfig.prototype.dbName;
        /**
         * @type {?}
         * @private
         */
        AsormConfig.prototype.remote;
        /**
         * @type {?}
         * @private
         */
        AsormConfig.prototype.masterDao;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/base/asorm.config.model.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AsormConfigModel = /** @class */ (function () {
        function AsormConfigModel() {
        }
        return AsormConfigModel;
    }());
    if (false) {
        /** @type {?} */
        AsormConfigModel.prototype.url;
        /** @type {?} */
        AsormConfigModel.prototype.dbName;
        /** @type {?} */
        AsormConfigModel.prototype.username;
        /** @type {?} */
        AsormConfigModel.prototype.password;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/asorm/enums/data.direction.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var DataDirection = {
        PUSH: "push",
        PULL: "pull",
    };

    exports.AsormConfig = AsormConfig;
    exports.AsormConfigModel = AsormConfigModel;
    exports.AttachementModel = AttachementModel;
    exports.AttachmentTypes = AttachmentTypes;
    exports.BaseEntity = BaseEntity;
    exports.Dao = Dao;
    exports.DataDirection = DataDirection;
    exports.Entity = Entity;
    exports.IDao = IDao;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=asorm.umd.js.map
