import { __awaiter } from 'tslib';
import PouchDB from 'pouchdb';
import PouchdbFind from 'pouchdb-find';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/helpers/constants.helper.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ConstantsHelper {
}
ConstantsHelper.CONFIG_KEY = 'AsromConfig';
if (false) {
    /** @type {?} */
    ConstantsHelper.CONFIG_KEY;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/db.manager.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
PouchDB.plugin(PouchdbFind);
// @dynamic
class DbManager {
    constructor() {
        PouchDB.plugin(PouchdbFind);
        this.dbs = [];
    }
    /**
     * @return {?}
     */
    static getInstance() {
        if (this.instance === undefined) {
            this.instance = new DbManager();
        }
        return this.instance;
    }
    /**
     * @param {?} db
     * @return {?}
     */
    addDB(db) {
        this.dbs.push(db);
    }
    /**
     * @param {?} db
     * @return {?}
     */
    remove(db) {
        // tslint:disable-next-line:no-shadowed-variable
        this.dbs = this.dbs.filter((/**
         * @param {?} db
         * @return {?}
         */
        db => {
            return db !== db;
        }));
    }
    /**
     * @param {?} name
     * @return {?}
     */
    getDBByName(name) {
        return this.dbs.find((/**
         * @param {?} item
         * @return {?}
         */
        item => item.name === name));
    }
    /**
     * @return {?}
     */
    getAll() {
        return this.dbs;
    }
    /**
     * @return {?}
     */
    getMasterDatabaseName() {
        /** @type {?} */
        let masterConf = {
            dbName: '',
            password: ''
        };
        masterConf = JSON.parse(localStorage.getItem(ConstantsHelper.CONFIG_KEY));
        return masterConf.dbName;
    }
    /**
     * @return {?}
     */
    getBaseDb() {
        if (this.baseDb == null || this.baseDb === undefined) {
            this.baseDb = this.createBaseDB();
        }
        return this.baseDb;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setBaseDB(value) {
        this.baseDb = value;
    }
    /**
     * @private
     * @return {?}
     */
    createBaseDB() {
        /** @type {?} */
        let db;
        if (this.getMasterDatabaseName() !== undefined && this.getMasterDatabaseName() !== '') {
            PouchDB.plugin(PouchdbFind);
            db = new PouchDB(this.getMasterDatabaseName(), { auto_compaction: true });
            return {
                name: this.getMasterDatabaseName(),
                db
            };
        }
        return null;
    }
}
if (false) {
    /** @type {?} */
    DbManager.instance;
    /**
     * @type {?}
     * @private
     */
    DbManager.prototype.dbs;
    /**
     * @type {?}
     * @private
     */
    DbManager.prototype.baseDb;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/attachment/attachement.manager.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AttachementManager {
    /**
     * @param {?} db
     */
    constructor(db) {
        this.db = db;
    }
    /**
     * @param {...?} args
     * @return {?}
     */
    delete(...args) {
    }
    /**
     * @param {?} _id
     * @param {?} name
     * @return {?}
     */
    get(_id, name) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.db.getAttachment(_id, name);
        });
    }
    /**
     * @param {?} attachement
     * @return {?}
     */
    save(attachement) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                /** @type {?} */
                const blob = new Blob([attachement.content], { type: attachement.type });
                /** @type {?} */
                const result = yield this.db.putAttachment(attachement.docId, attachement.attachmentId, blob, attachement.type);
                return result;
            }
            catch (err) {
                console.log(err);
            }
        });
    }
}
if (false) {
    /** @type {?} */
    AttachementManager.prototype.db;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/helpers/operator.helper.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OperatorHelper {
    /**
     * @param {?} operator
     * @param {?} value
     * @return {?}
     */
    static getValueWithOperator(operator, value) {
        switch (operator) {
            case '<':
                return { $lt: value };
            case '>':
                return { $gt: value };
            case '<=':
                return { $lte: value };
            case '>=':
                return { $gte: value };
            case '=':
                return { $eq: value };
            case '!=':
                return { $ne: value };
            case 'in':
                return { $in: value };
            case 'like':
                return { $regex: value };
            case 'match':
                return { $elemMatch: value };
            default: {
                throw new Error('Operator not found');
            }
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    static getEqualOperator(value) {
        return { $eq: value };
    }
    /**
     * @param {?} value
     * @return {?}
     */
    static buildOrOperation(value) {
        return {
            $or: value
        };
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/dao.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
PouchDB.plugin(PouchdbFind);
/**
 * @param {?} Class
 * @param {?=} name
 * @return {?}
 * @this {*}
 */
function Dao(Class, name) {
    return (/**
     * @template T
     * @param {?} constructor
     * @return {?}
     */
    (constructor) => {
        return class extends constructor {
            /**
             * @param {...?} args
             */
            constructor(...args) {
                super(arguments);
                this.query = { selector: {} };
                PouchDB.plugin(PouchdbFind);
                this.tableName = name ? name : (new Class()).constructor.name;
                this.isFromBase = this.isFromBase = (Object.getPrototypeOf((new Class()).constructor) + '').includes('BaseEntity');
                this.database = this.isFromBase ? DbManager.getInstance().getBaseDb().db : DbManager.getInstance().getDBByName(this.tableName).db;
            }
            /**
             * @param {?=} callback
             * @return {?}
             */
            get(callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let where;
                    if (!this.isFromBase) {
                        if (!callback) {
                            return this.getDocsInPromise();
                        }
                        if (callback.onPreExecute) {
                            callback.onPreExecute();
                        }
                        yield this.getDocsWithCallBack(callback);
                        if (callback.onPostExecute) {
                            callback.onPostExecute();
                        }
                        return;
                    }
                    where = this.where('table', this.tableName, '=');
                    if (callback) {
                        where.apply(callback);
                    }
                    else {
                        return where.apply();
                    }
                });
            }
            /**
             * @param {?} callback
             * @return {?}
             */
            getDocsWithCallBack(callback) {
                return new Promise((/**
                 * @param {?} resolve
                 * @return {?}
                 */
                (resolve) => __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let docs;
                    try {
                        docs = yield this.database.allDocs({
                            include_docs: true,
                            attachments: true
                        });
                        docs.rows = docs.rows.map((/**
                         * @param {?} item
                         * @return {?}
                         */
                        item => {
                            return item.doc;
                        }));
                        resolve(docs.rows);
                        if (docs.rows.length > 0) {
                            callback.onSuccess(docs.rows);
                        }
                        else {
                            if (callback.onEmpty) {
                                callback.onEmpty();
                            }
                        }
                    }
                    catch (e) {
                        callback.onError(e);
                    }
                })));
            }
            /**
             * @return {?}
             */
            getDocsInPromise() {
                return new Promise((/**
                 * @param {?} resolve
                 * @return {?}
                 */
                (resolve) => __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    const docs = yield this.database.allDocs({
                        include_docs: true,
                        attachments: true
                    });
                    docs.rows = docs.rows.map((/**
                     * @param {?} item
                     * @return {?}
                     */
                    item => {
                        return item.doc;
                    }));
                    resolve(docs.rows);
                    return docs.rows;
                })));
            }
            /**
             * @param {?} url
             * @param {?=} options
             * @return {?}
             */
            syncWith(url, options) {
                this.sync = this.database.sync(new PouchDB(url), (!options) ? {
                    live: true,
                    retry: true
                } : options);
                return this.sync;
            }
            /**
             * @param {?} url
             * @param {?=} options
             * @return {?}
             */
            replicateTo(url, options) {
                this.replication = this.database.replicate.to(new PouchDB(url), (!options) ? {
                    live: true,
                    retry: true
                } : options);
                return this.replication;
            }
            /**
             * @param {?} url
             * @param {?=} options
             * @return {?}
             */
            replicateFrom(url, options) {
                this.replication = this.database.replicate.from(new PouchDB(url), (!options) ? {
                    live: true,
                    retry: true
                } : options);
                return this.replication;
            }
            /**
             * @return {?}
             */
            getAttachementManager() {
                return new AttachementManager(this.database);
            }
            /**
             * @param {?} data
             * @param {?=} callback
             * @return {?}
             */
            put(data, callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!this.isFromBase) {
                        /** @type {?} */
                        let promise;
                        try {
                            if (data instanceof Array) {
                                promise = yield this.database.bulkDocs(data);
                            }
                            else {
                                promise = yield this.database.put(data);
                            }
                            return (promise);
                        }
                        catch (e) {
                            console.error(e);
                        }
                        return;
                    }
                    else {
                        this.putBaseMode(data, callback);
                    }
                });
            }
            /**
             * @param {?} data
             * @param {?=} callback
             * @return {?}
             */
            putBaseMode(data, callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let promise;
                    try {
                        if (data instanceof Array) {
                            data = data.map((/**
                             * @param {?} item
                             * @return {?}
                             */
                            item => {
                                Object.assign(item, { table: this.tableName });
                                return item;
                            }));
                            promise = yield this.database.bulkDocs(data);
                        }
                        else {
                            Object.assign(data, { table: this.tableName });
                            promise = yield this.database.put(data);
                        }
                        return (promise);
                    }
                    catch (e) {
                        console.error(e);
                    }
                });
            }
            /**
             * @param {?} doc
             * @param {?=} callback
             * @return {?}
             */
            delete(doc, callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!callback) {
                        return yield this.database.remove(doc);
                    }
                    this.deleteWithCallBack(doc, callback);
                });
            }
            /**
             * @param {?} value
             * @param {?=} callback
             * @return {?}
             */
            update(value, callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let target = yield this.apply();
                    console.log('raada', target);
                    target.forEach((/**
                     * @param {?} item
                     * @return {?}
                     */
                    item => {
                        Object.assign(item, value);
                    }));
                    if (!callback) {
                        return yield this.put(target);
                    }
                    else {
                        this.put(target, callback);
                    }
                });
            }
            /**
             * @param {?} newObjects
             * @return {?}
             */
            set(newObjects) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let item;
                    /** @type {?} */
                    const result = [];
                    for (item of this.whereRes) {
                        Object.assign(item, newObjects);
                        result.push(yield this.database.put(item));
                    }
                    return result;
                });
            }
            /**
             * @param {?} field
             * @param {?} value
             * @param {?=} operator
             * @param {?=} callback
             * @return {?}
             */
            deleteWhereWithCallBack(field, value, operator, callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let result;
                    /** @type {?} */
                    let toDelete;
                    if (callback.onPreExecute) {
                        callback.onPreExecute();
                    }
                    toDelete = yield this.where(field, value, operator).apply();
                    result = [];
                    try {
                        for (const item of toDelete) {
                            item[field] = value;
                            result.push(yield this.delete(item));
                        }
                        callback.onSuccess(result);
                    }
                    catch (e) {
                        callback.onError(e);
                    }
                    if (callback.onPostExecute) {
                        callback.onPostExecute();
                    }
                    return result;
                });
            }
            /**
             * @template THIS
             * @this {THIS}
             * @param {?} field
             * @param {?} value
             * @param {?=} operator
             * @return {THIS}
             */
            where(field, value, operator) {
                Object.assign((/** @type {?} */ (this)).query.selector, (/** @type {?} */ (this)).buildWhereClause(field, value, operator));
                return (/** @type {?} */ (this));
            }
            /**
             * @param {?=} callback
             * @return {?}
             */
            first(callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let result;
                    if (!this.isFromBase) {
                        if (!callback) {
                            result = yield this.database.find(this.query);
                            return result.docs[0];
                        }
                        yield this.applyWithCallBack(callback, true);
                        return;
                    }
                    this.where('table', this.tableName);
                    if (!callback) {
                        result = yield this.database.find(this.query);
                        return result.docs[0];
                        if (result.docs.length > 0) {
                            return result.docs[0];
                        }
                        return {};
                    }
                    this.applyWithCallBack(callback, true);
                });
            }
            /**
             * @param {?=} callback
             * @return {?}
             */
            apply(callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    let result;
                    if (this.isFromBase) {
                        this.where('table', this.tableName, '=');
                    }
                    if (!callback) {
                        result = yield this.database.find(this.query);
                        return result.docs;
                    }
                    yield this.applyWithCallBack(callback, false);
                });
            }
            /**
             * @param {?} callback
             * @param {?} isFirst
             * @return {?}
             */
            applyWithCallBack(callback, isFirst) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!this.isFromBase) {
                        if (callback.onPreExecute) {
                            callback.onPreExecute();
                        }
                        /** @type {?} */
                        const result = yield this.get();
                        if (result.docs.length > 0) {
                            if (isFirst) {
                                callback.onSuccess(result.docs[0]);
                            }
                            else {
                                callback.onSuccess(result.docs);
                            }
                        }
                        else {
                            if (callback.onEmpty) {
                                callback.onEmpty();
                            }
                        }
                        if (callback.onPostExecute) {
                            callback.onPostExecute();
                        }
                        return result;
                    }
                    if (callback.onPreExecute) {
                        callback.onPreExecute();
                    }
                    /** @type {?} */
                    const result = yield this.database.find(this.query);
                    if (result.docs.length > 0) {
                        if (isFirst) {
                            callback.onSuccess(result.docs[0]);
                        }
                        else {
                            callback.onSuccess(result.docs);
                        }
                    }
                    else {
                        if (callback.onEmpty) {
                            callback.onEmpty();
                        }
                    }
                    if (callback.onPostExecute) {
                        callback.onPostExecute();
                    }
                    return result;
                });
            }
            /**
             * @param {?} field
             * @param {?=} order
             * @return {?}
             */
            orderBy(field, order) {
                this.query.sort = this.buildOrderByClause(field, order);
                return this;
            }
            /**
             * @param {?} fields
             * @return {?}
             */
            select(fields) {
                this.query.fields = fields;
                return this;
            }
            /**
             * @param {?} limit
             * @return {?}
             */
            limit(limit) {
                this.query.limit = limit;
                return this;
            }
            /**
             * @param {?} field
             * @param {?} value
             * @param {?=} operator
             * @param {?=} callback
             * @return {?}
             */
            deleteWhere(field, value, operator, callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!callback) {
                        return yield this.deleteWhereAndGetResult(field, value, operator);
                    }
                    this.deleteWhereWithCallBack(field, value, operator, callback);
                });
            }
            /**
             * @param {?} field
             * @param {?} value
             * @param {?} operator
             * @return {?}
             */
            deleteWhereAndGetResult(field, value, operator) {
                return __awaiter(this, void 0, void 0, function* () {
                    /** @type {?} */
                    const toDeleteList = yield this.where(field, value, operator).apply();
                    /** @type {?} */
                    const result = [];
                    for (const item of toDeleteList) {
                        result.push(this.delete(item));
                    }
                    return yield Promise.all(result);
                });
            }
            /**
             * @param {?} field
             * @param {?=} order
             * @return {?}
             */
            buildOrderByClause(field, order) {
                /** @type {?} */
                const result = {};
                result[field] = (order) ? order : 'asc';
                return JSON.parse(JSON.stringify([result]));
            }
            /**
             * @param {?} field
             * @param {?} value
             * @param {?=} operator
             * @return {?}
             */
            buildWhereClause(field, value, operator) {
                /** @type {?} */
                const result = {};
                result[field] = (operator) ? OperatorHelper.getValueWithOperator(operator, value) : OperatorHelper.getEqualOperator(value);
                return JSON.parse(JSON.stringify(result));
            }
            /**
             * @param {?} field
             * @param {?} value
             * @param {?=} operator
             * @return {?}
             */
            orWhere(field, value, operator) {
                this.query.selector = {
                    $or: [this.query.selector, this.buildWhereClause(field, value, operator)]
                };
                return this;
            }
            /**
             * @param {?} doc
             * @param {?} callback
             * @return {?}
             */
            deleteWithCallBack(doc, callback) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (callback.onPreExecute) {
                        callback.onPreExecute();
                    }
                    try {
                        callback.onSuccess(yield this.database.remove(doc));
                    }
                    catch (e) {
                        callback.onError(e);
                    }
                    if (callback.onPostExecute) {
                        callback.onPostExecute();
                    }
                });
            }
        };
    });
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/entity.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?=} name
 * @return {?}
 */
function Entity(name) {
    return (/**
     * @template T
     * @param {?} constructor
     * @return {?}
     */
    (constructor) => {
        PouchDB.plugin(PouchdbFind);
        /** @type {?} */
        let db;
        /** @type {?} */
        const chosenName = name ? name : constructor.name;
        if ((Object.getPrototypeOf(constructor) + '').includes('BaseEntity')) {
            //  DbManager.getInstance().getBaseDb();
        }
        else {
            if (DbManager.getInstance().getDBByName(chosenName) == null) {
                db = new PouchDB(chosenName);
                DbManager.getInstance().addDB({
                    name: chosenName,
                    db
                });
            }
        }
        return constructor;
    });
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/base/i.dao.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class IDao {
}
if (false) {
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.get = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.put = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.delete = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.select = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.where = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.orderBy = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.limit = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.apply = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.first = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.sync = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.deleteWhere = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.update = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.set = function (args) { };
    /**
     * @abstract
     * @param {...?} args
     * @return {?}
     */
    IDao.prototype.orWhere = function (args) { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/base/i.callback.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ICallback() { }
if (false) {
    /** @type {?|undefined} */
    ICallback.prototype.onPreExecute;
    /** @type {?} */
    ICallback.prototype.onSuccess;
    /** @type {?} */
    ICallback.prototype.onError;
    /** @type {?|undefined} */
    ICallback.prototype.onEmpty;
    /** @type {?|undefined} */
    ICallback.prototype.onPostExecute;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/attachment/models/attachement.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AttachementModel {
}
if (false) {
    /** @type {?} */
    AttachementModel.prototype.docId;
    /** @type {?} */
    AttachementModel.prototype.attachmentId;
    /** @type {?} */
    AttachementModel.prototype.rev;
    /** @type {?} */
    AttachementModel.prototype.content;
    /** @type {?} */
    AttachementModel.prototype.type;
    /** @type {?} */
    AttachementModel.prototype.callback;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/attachment/types.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AttachmentTypes {
}
AttachmentTypes.JPG = 'image/jpg';
AttachmentTypes.PNG = 'image/png';
AttachmentTypes.TEXT = 'text/plain';
AttachmentTypes.OCTETSTREAM = 'application/octet-stream';
if (false) {
    /** @type {?} */
    AttachmentTypes.JPG;
    /** @type {?} */
    AttachmentTypes.PNG;
    /** @type {?} */
    AttachmentTypes.TEXT;
    /** @type {?} */
    AttachmentTypes.OCTETSTREAM;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/base/BaseEntity.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BaseEntity {
    constructor() {
        this.baseEntity = '';
    }
}
if (false) {
    /** @type {?} */
    BaseEntity.prototype.baseEntity;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/master.doa.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
PouchDB.plugin(PouchdbFind);
class MasterDoa {
    /**
     * @param {?} database
     */
    constructor(database) {
        this.query = { selector: {} };
        PouchDB.plugin(PouchdbFind);
        this.database = database;
    }
    /**
     * @param {?=} callback
     * @return {?}
     */
    get(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!callback) {
                return this.getDocsInPromise();
            }
            if (callback.onPreExecute) {
                callback.onPreExecute();
            }
            yield this.getDocsWithCallBack(callback);
            if (callback.onPostExecute) {
                callback.onPostExecute();
            }
            return;
        });
    }
    /**
     * @param {?} callback
     * @return {?}
     */
    getDocsWithCallBack(callback) {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let docs;
            try {
                docs = yield this.database.allDocs({
                    include_docs: true,
                    attachments: true
                });
                docs.rows = docs.rows.map((/**
                 * @param {?} item
                 * @return {?}
                 */
                item => {
                    return item.doc;
                }));
                resolve(docs.rows);
                if (docs.rows.length > 0) {
                    callback.onSuccess(docs.rows);
                }
                else {
                    if (callback.onEmpty) {
                        callback.onEmpty();
                    }
                }
            }
            catch (e) {
                callback.onError(e);
            }
        })));
    }
    /**
     * @return {?}
     */
    getDocsInPromise() {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            const docs = yield this.database.allDocs({
                include_docs: true,
                attachments: true
            });
            docs.rows = docs.rows.map((/**
             * @param {?} item
             * @return {?}
             */
            item => {
                return item.doc;
            }));
            resolve(docs.rows);
            return docs.rows;
        })));
    }
    /**
     * @param {?} data
     * @param {?=} callback
     * @return {?}
     */
    put(data, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let promise;
            try {
                if (data instanceof Array) {
                    promise = yield this.database.bulkDocs(data);
                }
                else {
                    promise = yield this.database.put(data);
                }
                return (promise);
            }
            catch (e) {
                console.error(e);
            }
            return;
        });
    }
    /**
     * @param {?} doc
     * @param {?=} callback
     * @return {?}
     */
    delete(doc, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!callback) {
                return yield this.database.remove(doc);
            }
            this.deleteWithCallBack(doc, callback);
        });
    }
    /**
     * @param {?} field
     * @param {?} value
     * @param {?=} operator
     * @param {?=} callback
     * @return {?}
     */
    updateWhere(field, value, operator, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!callback) {
                this.whereRes = yield this.where(field, value, operator).apply();
                //  return await this.updateAndGetResult(toUpdate, newData, field, value);
            }
            //  this.updateWithCallBack(field, value, operator, callback);
            return this;
        });
    }
    /**
     * @param {?} newObjects
     * @return {?}
     */
    set(newObjects) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let item;
            /** @type {?} */
            const result = [];
            for (item of this.whereRes) {
                Object.assign(item, newObjects);
                result.push(yield this.database.put(item));
            }
            return result;
        });
    }
    /**
     * @param {?} field
     * @param {?} value
     * @param {?=} operator
     * @param {?=} callback
     * @return {?}
     */
    updateWithCallBack(field, value, operator, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let item;
            /** @type {?} */
            let result;
            /** @type {?} */
            let toUpdate;
            if (callback.onPreExecute) {
                callback.onPreExecute();
            }
            toUpdate = yield this.where(field, value, operator).apply();
            result = [];
            try {
                for (item of toUpdate) {
                    item[field] = value;
                    result.push(yield this.database.put(item));
                }
                callback.onSuccess(result);
            }
            catch (e) {
                callback.onError(e);
            }
            if (callback.onPostExecute) {
                callback.onPostExecute();
            }
            return result;
        });
    }
    /**
     * @param {?} field
     * @param {?} value
     * @param {?=} operator
     * @param {?=} callback
     * @return {?}
     */
    deleteWhereWithCallBack(field, value, operator, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let result;
            /** @type {?} */
            let toDelete;
            if (callback.onPreExecute) {
                callback.onPreExecute();
            }
            toDelete = yield this.where(field, value, operator).apply();
            result = [];
            try {
                for (const item of toDelete) {
                    item[field] = value;
                    result.push(yield this.delete(item));
                }
                callback.onSuccess(result);
            }
            catch (e) {
                callback.onError(e);
            }
            if (callback.onPostExecute) {
                callback.onPostExecute();
            }
            return result;
        });
    }
    /**
     * @param {?} toUpdate
     * @param {?} newData
     * @param {?} field
     * @param {?} value
     * @return {?}
     */
    updateAndGetResult(toUpdate, newData, field, value) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let item;
            /** @type {?} */
            const result = [];
            for (item of toUpdate) {
                item[field] = newData;
                result.push(yield this.database.put(item));
            }
            return result;
        });
    }
    /**
     * @template THIS
     * @this {THIS}
     * @param {?} field
     * @param {?} value
     * @param {?=} operator
     * @return {THIS}
     */
    where(field, value, operator) {
        Object.assign((/** @type {?} */ (this)).query.selector, (/** @type {?} */ (this)).buildWhereClause(field, value, operator));
        return (/** @type {?} */ (this));
    }
    /**
     * @param {?=} callback
     * @return {?}
     */
    first(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let result;
            if (!callback) {
                result = yield this.database.find(this.query);
                return result.docs[0];
            }
            yield this.applyWithCallBack(callback, true);
        });
    }
    /**
     * @param {?=} callback
     * @return {?}
     */
    apply(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let result;
            if (!callback) {
                result = yield this.database.find(this.query);
                return result.docs;
            }
            yield this.applyWithCallBack(callback, false);
        });
    }
    /**
     * @param {?} callback
     * @param {?} isFirst
     * @return {?}
     */
    applyWithCallBack(callback, isFirst) {
        return __awaiter(this, void 0, void 0, function* () {
            if (callback.onPreExecute) {
                callback.onPreExecute();
            }
            /** @type {?} */
            const result = yield this.database.find(this.query);
            if (result.docs.length > 0) {
                if (isFirst) {
                    callback.onSuccess(result.docs[0]);
                }
                else {
                    callback.onSuccess(result.docs);
                }
            }
            else {
                if (callback.onEmpty) {
                    callback.onEmpty();
                }
            }
            if (callback.onPostExecute) {
                callback.onPostExecute();
            }
            return result;
        });
    }
    /**
     * @param {?} field
     * @param {?=} order
     * @return {?}
     */
    orderBy(field, order) {
        this.query.sort = this.buildOrderByClause(field, order);
        return this;
    }
    /**
     * @param {?} fields
     * @return {?}
     */
    select(fields) {
        this.query.fields = fields;
        return this;
    }
    /**
     * @param {?} limit
     * @return {?}
     */
    limit(limit) {
        this.query.limit = limit;
        return this;
    }
    /**
     * @param {?} field
     * @param {?} value
     * @param {?=} operator
     * @param {?=} callback
     * @return {?}
     */
    deleteWhere(field, value, operator, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!callback) {
                return yield this.deleteWhereAndGetResult(field, value, operator);
            }
            this.deleteWhereWithCallBack(field, value, operator, callback);
        });
    }
    /**
     * @param {?} field
     * @param {?} value
     * @param {?} operator
     * @return {?}
     */
    deleteWhereAndGetResult(field, value, operator) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            const toDeleteList = yield this.where(field, value, operator).apply();
            /** @type {?} */
            const result = [];
            for (const item of toDeleteList) {
                result.push(yield this.delete(item));
            }
            return result;
        });
    }
    /**
     * @param {?} value
     * @param {?=} callback
     * @return {?}
     */
    update(value, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            let target = yield this.apply();
            if (!callback) {
                target = target.map((/**
                 * @param {?} item
                 * @return {?}
                 */
                item => {
                    return Object.assign(item, value);
                }));
            }
            return yield this.put(target);
        });
    }
    /**
     * @param {?} field
     * @param {?=} order
     * @return {?}
     */
    buildOrderByClause(field, order) {
        /** @type {?} */
        const result = {};
        result[field] = (order) ? order : 'asc';
        return JSON.parse(JSON.stringify([result]));
    }
    /**
     * @param {?} field
     * @param {?} value
     * @param {?=} operator
     * @return {?}
     */
    buildWhereClause(field, value, operator) {
        /** @type {?} */
        const result = {};
        result[field] = (operator) ? OperatorHelper.getValueWithOperator(operator, value) : OperatorHelper.getEqualOperator(value);
        return JSON.parse(JSON.stringify(result));
    }
    /**
     * @param {?} field
     * @param {?} value
     * @param {?=} operator
     * @return {?}
     */
    orWhere(field, value, operator) {
        this.query.selector = {
            $or: [this.query.selector, this.buildWhereClause(field, value, operator)]
        };
        return this;
    }
    /**
     * @param {?} doc
     * @param {?} callback
     * @return {?}
     */
    deleteWithCallBack(doc, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            if (callback.onPreExecute) {
                callback.onPreExecute();
            }
            try {
                callback.onSuccess(yield this.database.remove(doc));
            }
            catch (e) {
                callback.onError(e);
            }
            if (callback.onPostExecute) {
                callback.onPostExecute();
            }
        });
    }
}
if (false) {
    /** @type {?} */
    MasterDoa.prototype.tableName;
    /** @type {?} */
    MasterDoa.prototype.database;
    /** @type {?} */
    MasterDoa.prototype.query;
    /** @type {?} */
    MasterDoa.prototype.sync;
    /** @type {?} */
    MasterDoa.prototype.whereRes;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/asorm.db.confing.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
PouchDB.plugin(PouchdbFind);
class AsormConfig {
    /**
     * @param {?} config
     */
    constructor(config) {
        try {
            this.url = config.url;
            this.dbName = config.dbName;
            localStorage.setItem(ConstantsHelper.CONFIG_KEY, JSON.stringify(config));
            /** @type {?} */
            const pouchOpts = (config.username && config.password) ? {
                skipSetup: true,
                ajax: {
                    cache: false,
                    timeout: 30000
                },
                auth: {
                    username: config.username,
                    password: config.password,
                }
            } :
                {
                    skipSetup: true
                };
            this.remote = new PouchDB(this.url
                + '/' + this.dbName, pouchOpts);
            DbManager.getInstance().getBaseDb().database = DbManager.getInstance().getBaseDb().db;
        }
        catch (err) {
            console.log(err);
        }
    }
    /**
     * @param {?=} options
     * @return {?}
     */
    synchronize(options) {
        try {
            if (DbManager.getInstance().getBaseDb().database) {
                this.sync = DbManager.getInstance().getBaseDb().database.sync(this.remote, (!options) ? {
                    live: true,
                    retry: true
                } : options);
                return this.sync;
            }
        }
        catch (e) {
            console.log('error', e);
        }
    }
    /**
     * @return {?}
     */
    getMasterDao() {
        if (this.masterDao === undefined) {
            this.masterDao = new MasterDoa(DbManager.getInstance().getBaseDb().db);
        }
        return this.masterDao;
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    AsormConfig.prototype.sync;
    /**
     * @type {?}
     * @private
     */
    AsormConfig.prototype.url;
    /**
     * @type {?}
     * @private
     */
    AsormConfig.prototype.dbName;
    /**
     * @type {?}
     * @private
     */
    AsormConfig.prototype.remote;
    /**
     * @type {?}
     * @private
     */
    AsormConfig.prototype.masterDao;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/base/asorm.config.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AsormConfigModel {
}
if (false) {
    /** @type {?} */
    AsormConfigModel.prototype.url;
    /** @type {?} */
    AsormConfigModel.prototype.dbName;
    /** @type {?} */
    AsormConfigModel.prototype.username;
    /** @type {?} */
    AsormConfigModel.prototype.password;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/asorm/enums/data.direction.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const DataDirection = {
    PUSH: "push",
    PULL: "pull",
};

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: asorm.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AsormConfig, AsormConfigModel, AttachementModel, AttachmentTypes, BaseEntity, Dao, DataDirection, Entity, IDao };
//# sourceMappingURL=asorm.js.map
